#!/bin/bash
#
# Banish 1.4.7 for IPCop 1.4.18+
# Banish uninstall script
# Version 1.4.7
#
# SID Solutions
# http://sidsolutions.net
# Copyright (c) 2005/07/10 Sid McLaurin 
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
# $Id: uninstall_Banish.sh,v 1.4.7 2008/03/18 14:08 Sid McLaurin

# Print uninstall message to console
echo
/bin/echo -e "\033[1;32mBanish 1.4.7 uninstall \033[0m"
/usr/bin/logger -t "banish" "Starting Banish 1.4.7 Uninstall"
echo

# Remove Banish rules
echo -e "Flushing Banish rules................\c"
/bin/cp -p /var/ipcop/Banish/ip_Banishlist /var/ipcop/Banish/rm_Banishlist
/etc/rc.d/rc.Banish stop
echo -e "Done!\n"

# Change to /tmp directory
cd /tmp

# Remove files
echo -e "Removing files.......................\c"

/bin/rm /usr/local/bin/setBanish >/dev/null 2>&1
/bin/rm /usr/local/bin/Banish_Sort.pl >/dev/null 2>&1
/bin/rm /home/httpd/cgi-bin/Banish.cgi >/dev/null 2>&1
/bin/rm /home/httpd/cgi-bin/Banish_Credits.cgi >/dev/null 2>&1
/bin/rm /home/httpd/cgi-bin/Banish_Settings.cgi >/dev/null 2>&1
/bin/rm /home/httpd/cgi-bin/logs.cgi/Banishlog.dat >/dev/null 2>&1
/bin/rm /etc/rc.d/rc.Banish >/dev/null 2>&1
/bin/rm -rf /home/httpd/html/images/Banish >/dev/null 2>&1
/bin/rm -rf /var/ipcop/Banish >/dev/null 2>&1
echo "Done!"


# Unappending files
echo -e "Restoring files......................\c"

# Remove header entry
/bin/cat /var/ipcop/header.pl | sed -e '/Added for Banish/,/End Banish/d' > /tmp/header.pl.tmp
/bin/cp /tmp/header.pl.tmp /var/ipcop/header.pl
/bin/rm /tmp/header.pl.tmp

# Removing Language entries
# English
/bin/rm /var/ipcop/addon-lang/Banish.en.pl

# Deutsch
/bin/rm /var/ipcop/addon-lang/Banish.de.pl

# French
/bin/rm /var/ipcop/addon-lang/Banish.fr.pl

# Italain
/bin/rm /var/ipcop/addon-lang/Banish.it.pl

# Spanish
/bin/rm /var/ipcop/addon-lang/Banish.es.pl

# Portuguese
/bin/rm /var/ipcop/addon-lang/Banish.pt.pl

# Netherlands
/bin/rm /var/ipcop/addon-lang/Banish.nl.pl

# Lang Script Cache Compliation
perl -e "require '//var/ipcop/lang.pl'; &Lang::BuildCacheLang"

# Remove whois tweak
/bin/cat /home/httpd/cgi-bin/ipinfo.cgi | sed -e '/Added for Banish/,/End Banish/d' > /tmp/ipinfo.cgi.tmp
/usr/bin/perl -pi.old -e "s/address \./addr \./g" ipinfo.cgi.tmp
/bin/cp /tmp/ipinfo.cgi.tmp /home/httpd/cgi-bin/ipinfo.cgi
/bin/rm /tmp/ipinfo.cgi.tmp
/bin/rm /tmp/ipinfo.cgi.tmp.old

# Remove firewall log tweak
/bin/cat /home/httpd/cgi-bin/logs.cgi/firewalllog.dat | sed -e '/Added for Banish/,/End Banish/d' > /tmp/firewalllog.dat.tmp
/bin/cp /tmp/firewalllog.dat.tmp /home/httpd/cgi-bin/logs.cgi/firewalllog.dat
/bin/rm /tmp/firewalllog.dat.tmp

# Remove system log tweak
/bin/cat /home/httpd/cgi-bin/logs.cgi/log.dat | sed -e '/Added for Banish/,/End Banish/d' > /tmp/log.dat.tmp
/bin/cp /tmp/log.dat.tmp /home/httpd/cgi-bin/logs.cgi/log.dat
/bin/rm /tmp/log.dat.tmp

# Restore rc.firewall.local
/bin/cp -p /SID_Solutions/Banish/rc.local.bak /etc/rc.d/rc.local
echo "Done!"

# Remove backup directory
/bin/rm -rf /SID_Solutions/Banish >/dev/null 2>&1

# Remove uninstall script
rm -f /usr/local/bin/uninstall_Banish.sh

echo
echo -e "\033[1;32mBanish 1.4.7 Uninstall Complete \033[0m"
/usr/bin/logger -t "banish" "Banish-1.4.7 Uninstall Completed"
echo
